#ifndef _I2C_H_
#define _I2C_H_
#include<system.h>

/* THis set of library routines uses the on-board I2C hardware
 * on the 16F877 or 16F877A to use an I2C interface. Note that since
 * some of the register names are different in the two devices (though
 * their memory locations are the same, the names are declared and
 * used in this file.
 * 
 */
/* my versions of the register addresses */
char SSPSTUT@0x0007;

char I2C_init(char rate);    // init hardware
void I2C_start(void);   // start command
void I2C_restart(void);  // restart
void I2C_stop(void);      //stop
char I2C_write(char data);     // write
char I2C_read(char ack);          //read
void I2C_busy(void);
void I2C_wait(void);
#endif //_I2C_H_
