/***************************************************
 * Trailer Board
 *
 * ************************************************/
        
#include <system.h>

#include "EESD.h"

#pragma DATA _CONFIG1H, _OSC_HS_1H //10 mhz
#pragma DATA _CONFIG2H, _WDT_OFF_2H 
#pragma DATA _CONFIG4L, _LVP_OFF_4L 
#pragma DATA _CONFIG3H, _MCLRE_ON_3H

#pragma CLOCK_FREQ 10000000

//defining global variables 
bool backup = false;
short left_blinker = 0;
short brake = 0;
short right_blinker = 0;
bool door = false;
short loop_count = 99;
short acknowledge = 0;
bool transmit_error = 0;
short transmit_loop_count = 0;
short true_false = 1;
  
void main(void) {

  unsigned short IR_range_left;
  unsigned short IR_range_right;

  short temp_in = 50;
  short temp_out = 50;
  
  short temp_in_identifier = 0b00000010;
  short temp_out_identifier = 0b00000011;
  short true_false_identifier = 0b00000000;
  short backup_identifier = 0b00000001;
      
  int i = 0;
  int j = 0;
  int k = 0;
  
  short ultra_range_left = 0;
  short range_avg_left = 0;
  short range_left[6] = {0,0,0,0,0,0};
  
  short ultra_range_right = 0;
  short range_avg_right = 0;
  short range_right[6] = {0,0,0,0,0,0};

  bool on;  
    
  LCD_init();
  I2C_init();
  interrupt_init(); //enable interrupt on change for B0 and B4-B7
  zigbee_init();
  
  if(portb.0) {  //door open
    intcon2.6 = 0; // B0 interrupts on falling edge
    door = 1;
  }
  
  if(!portb.0) { //door closed
    intcon2.6 = 1; //B0 interrupts on rising edge
    door = 0;
  }
  
  //I2C_stop();  //clear the bus
  //I2C_9clocks(); //shift out nine clocks
  
      
  while(1) {
        
    while(backup) {
      //IR_init_left();    //a/d convert from IR sensors to get a distance measurement
      //IR_range_left = IR_range_inch();
      IR_init_right();
      IR_range_right = IR_range_inch();
      
      //if(IR_range_left << IR_range_right) {   //send lower measurement to Display
        //send_to_display(backup_identifier, IR_range_left);    //send left range
        
      //}
      //if(IR_range_left >= IR_range_right) {   //send lower measurement to Display
        send_to_display(backup_identifier, IR_range_right);    //send right range
        
      //}
    }
    
    //while not in backup mode, monitor everything else   
    /*if(left_blinker) {
      on = left_blinker_shunt();
      if(on)
        true_false.5 = 1;  //turn left blinker on
      if(!on)
        true_false.5 = 0;  //turn left blinker off
    }

    if(!left_blinker) {
      true_false.5 = 0;  //turn left blinker off
    }*/
    
    if(right_blinker) {
           
      on = right_blinker_shunt();
      if(on) {
        true_false.6 = 1;  //send turn on left blinker command
        //LCD_printf("blink on");
      }
      if(!on) {
        true_false.6 = 0;  //send turn off left blinker command
        //LCD_printf("blink off");
      }
    }
    
    if(!right_blinker) {
      true_false.6 = 0;  //turn right blinker off
    }
    
    /*if(brake) {
      on = brake_shunt();
      if(on)
        true_false.7 = 1;  //send turn on brake light
      if(!on)
        true_false.7 = 0;  //send turn off brake light
    }
    
    if(!brake) {
      true_false.7 = 0;  //turn brake light off
    }*/
   
    if(!door) {
      true_false.0 = 0;//send door closed (turn off light)
    }   
   
    if(door) {
      true_false.0 = 1;//send door open (turn on light)
      //turn on buzzer
    }
    
   
    
    //if(ultra_range_left != 255) {            //valid range

       initiate_ultra_range(0xE2);   //start next reading
       initiate_ultra_range(0xE0);   //start next reading
       delay_ms(70);
       ultra_range_left = get_ultra_range(0xE2,0xE3);  //ping ultrasonic for measurement
       ultra_range_right = get_ultra_range(0xE0,0xE1);  //ping ultrasonic for measurement
       
       LCD_setpos(0,10);
       LCD_dec(ultra_range_left);
       LCD_setpos(1,10);
       LCD_dec(ultra_range_right);       
       
       if(i >= 4) {
         i = 0;
       }
       
       range_left[i] = ultra_range_left;
       i = i+1;
       
       range_avg_left = (range_left[0]/4 + range_left[1]/4 + range_left[2]/4 + range_left[3]/4); // + range_left[3]/6 + range_left[5]/6);
       
       if(range_avg_left << 20) {
         true_false.3 = 1;  //left blind true
       }
       if(range_avg_left >= 20) {
         true_false.3 = 0;  //left blind false
       }       
       
       
       
       
       if(j >= 4) {
         j = 0;
       }
       
       range_right[j] = ultra_range_right;
       j = j+1;
       
       range_avg_right = (range_right[0]/4 + range_right[1]/4 + range_right[2]/4 + range_right[3]/4); // + range_left[3]/6 + range_left[5]/6);
       
       if(range_avg_right << 20) {
         true_false.2 = 1;  //left blind true
       }
       if(range_avg_right >= 20) {
         true_false.2 = 0;  //left blind false
       }     
       
     send_to_display(true_false_identifier, true_false);      //send true_false to display
     
     
  loop_count = 0;   
  if(loop_count >= 100) {  //get temperature measurement every 100 loops
      loop_count = 0;  //reset loop_count
      
      //temp_in = get_temp(0x9C, 0x9D); 
      temp_out = get_temp(0x9E, 0x9F);
      
      if(temp_out <= 32) {
        true_false.1 = 1;
      }
      if(temp_out >= 33) {
        true_false.1 = 0;
      }
      
      //send_to_display(temp_in_identifier, temp_in);  //Send temps to Display
      send_to_display(temp_out_identifier, temp_out);
      LCD_setpos(0,0);
      LCD_dec(temp_out);
   }
   //loop_count = loop_count+1; 
  }
}

void interrupt(void) {

  if (intcon.0==1) { //interrupt for B4-B7
        
    if(portb.4==1) {  //Backup line goes high
      backup = true; //enable backup ranging/display
    }   
    if(portb.4==0) {  //Backup line goes low
      backup = false; //disable backup ranging/display
    }
    /*if(portb.5==1) {  //Left Blinker goes high
      left_blinker = true;
    }
    if(portb.5==0) {  //Left Blinker goes low
      left_blinker = false;
    }
    if(portb.6==1) {  //Brake goes high
      brake = true;
    }
    if(portb.6==0) {  //Brake goes low
      brake = false;
    }*/
    if(portb.7==1) {  //Right Blinker goes high
      right_blinker = true;
    }
    if(portb.7==0) {  //Right Blinker goes low
      right_blinker = false;  //turn light off
      //LCD_printf("false1");
    }
    intcon.0 = 0; //clear interrupt
  }
  
  if(intcon.1 = 1) {  
    if(!portb.0) {
      door = false;  //door closed
      intcon.1 = 0;  //clear interrupt
      intcon2.6 = 1;  //set interrupt to rising edge triggered
    }
    
    if(portb.0) {
      door = true;    //door open
      intcon.1 = 0;  //clear interrupt
      intcon2.6 = 0;  //set interrupt to falling edge triggered
    }
  }
  
  if(pir1.5==1) { //the equiv of getc
	acknowledge = rcreg;
	pir1.5 = 0;  //clear interrupt
  } 
}

void send_to_display(short identifier, short data) {

    transmit_error = false;
    transmit_loop_count = 0;
    
  //while(!acknowledge && !transmit_error) {
      while(!txsta.1) { }
	  txreg = 0x7E;         //7E signals beginning of msg	
	  while(!txsta.1) { }
	  txreg = identifier;   //identifier	
	  while(!txsta.1) { }
	   if(data == 126) {
	      data = 125;
	    }
	  txreg = data;         //data 	
	
	  /*delay_ms(50);
	  transmit_loop_count = transmit_loop_count + 1; 
	  if(transmit_loop_count >= 10) {
	    transmit_error = 1;
	    //LCD_setpos(0,0);
	    //LCD_printf("Transmit Error");
	    delay_ms(500);
	  }
	 }*/
	 acknowledge = 0;
	 LCD_setpos(0,0);
	 LCD_bin(identifier);
	 LCD_setpos(1,0);
	 LCD_bin(data);
	 
	 
}

void interrupt_init(void) {
  trisb = 0b11111111;  // port B all input
  intcon2.6 = 1;  //disables internal pull-ups
  intcon = 0b11011000;  //sets interrupt control register for B4-B7, and B0
  pie1.5 = 1;            //enables interrupt flag on receive zigbee byte
}